;
;	Transcript service for PC-9801 MS-DOS ( Ver 1.4 )
;	Common header
;	Written by  Oka  /  Feb. 7, 1988.
;	Modified for FMR by SHU on Jan. 1989
;	Ver. 2.1 by SHU  /  Mar. 11, 1989
;	Ver. 3.2 by SHU  /  Apr. 11, 1989
;	Ver. 3.3 by SHU  /  Apr. 29, 1989
;	Ver. 3.4 by SHU  /  May. 11, 1989
;	Ver. 4.0 by SHU  /  May. 27, 1989
;	Ver. 4.1 by SHU  /  Jun. 15, 1989
;	Ver. 4.2 by SHU  /  Jan. 13, 1990
;	Ver. 4.3 by SHU  /  Feb. 15, 1990
;	Ver. 5.0 by SHU  /  Feb. 21, 1990
;	Ver. 5.1 by SHU  /  Mar.  6, 1990
;

VERSION		equ	'FM 5.1'
VERSIONL	equ	'FMR version 5.1'

XSERV_INT	=	0F9h		; Transcript service routine interrupt.

ON		=	-1
OFF		=	0
;	FMR series
;FMR50		=	1
;FMTOWNS	=	2
;FMR70		=	4
FMR		=	ON		; set OFF for PC-9801

FUNC_MAX	=	7

IFDEF	FMR
  BANK_PORT_W	=	402h		; write plane address for FMR-70/60 only
  BANK_W_P0	=	01h		; write plane 0
  BANK_PORT	=	404h		; read plane address for FMR-70/60 only
  BANK_ON_NUM	=	80h		; read/write to main memory
  BANK_R_P0	=	00h		; read plane 0
  BANK_OFF_NUM =	0
  TVRAM_SEG_R70 =	0F800h		; vram segment for FMR-70/60
  TXTBUF_SEG_R70 =	0D000h
  TVBUF_SEG_R70 =	0E000h
  TVBUF_SEG_R70G =	0CE00h
  TVRAM_SEG_R50 =	0C800h		; vram segment for FMR-50/30
  TVBUF_SEG_R50 =	0E000h
  TVBUF_SEG_R50G =	0C000h
  ATTR_OFF	=	02000h
; CUTBUF_SEG	=	0E200h
ELSE
  BANK_PORT	=	0A6h
  BANK_ON_NUM	=	1
  BANK_OFF_NUM	=	0
  TXTBUF_SEG	=	0B000h
  TVRAM_SEG	=	0A000h
  ATTR_OFF	=	02000h
  TVBUF_SEG	=	0A800h
; CUTBUF_SEG	=	0AA00h
ENDIF

ROW_WIDTH     =  23
COLUMN_WIDTH  =  80

BS	    =	8
TAB	    =	9
LF	    =  10
FS	    =  12
CR          =  13
ESCAPE	    =  27			; change for MASM 5.1

CTRL_A      =  01h
CTRL_B      =  02h
CTRL_C      =  03h
CTRL_D      =  04h
CTRL_E      =  05h
CTRL_F      =  06h
CTRL_G      =  07h
CTRL_H      =  08h
CTRL_I      =  09h
CTRL_J      =  0Ah
CTRL_K      =  0Bh
CTRL_L      =  0Ch
CTRL_M      =  0Dh
CTRL_N      =  0Eh
CTRL_O      =  0Fh
CTRL_P      =  10h
CTRL_Q      =  11h
CTRL_R      =  12h
CTRL_S      =  13h
CTRL_T      =  14h
CTRL_U      =  15h
CTRL_V      =  16h
CTRL_W      =  17h
CTRL_X      =  18h
CTRL_Y      =  19h
CTRL_Z      =  1Ah

VACANT_CHAR	=  0000h
TAB_CHAR	=  001Ch
NTAB_CHAR	=  00FFh
EOL_CHAR	=  001Fh

IFDEF	FMR
  IFDEF	FMR70
  ATR_REVERSE	= 0800h
  ATR_WHITE	= 0007h
  ATR_YELLOW	= 0006h
  ATR_CYAN	= 0005h
  ELSE					; for FMR-50 and the other
  ATR_REVERSE	= 08h
  ATR_WHITE	= 07h
  ATR_YELLOW	= 06h
  ATR_CYAN	= 05h
  ATR_KANJI_1	= 40h
  ATR_KANJI_2	= 80h
  CODE_KANJI_1	= 0FEh
  ENDIF
ELSE
  ATR_WHITE	= 0E1h
  ATR_YELLOW	= 0C1h
  ATR_CYAN	= 0A1h
  ATR_REVERSE	= 04h
ENDIF

